#include "coord.h"
#include "camera.h"
#include "material.h"
#include "light.h"

coord_c::
coord_c (void)
{
   NumberLinkedFace = 0;
}

coord_c::
coord_c (const coord_c& coord)
{
   word index;

   Point3D = coord.Point3D;
   Point2D = coord.Point2D;
   Normale = coord.Normale;

   NumberLinkedFace = coord.NumberLinkedFace;
   for (index=0; index<NumberLinkedFace; index++)
   {
      LinkedFace[index] = coord.LinkedFace[index];
   }
}

coord_c& coord_c::
operator= (const coord_c& coord)
{
   word  index;

   Point3D = coord.Point3D;
   Point2D = coord.Point2D;
   Normale = coord.Normale;

   NumberLinkedFace = coord.NumberLinkedFace;
   for (index=0; index<NumberLinkedFace; index++)
   {
      LinkedFace[index] = coord.LinkedFace[index];
   }

   return *this;
}

coord_c& coord_c::
operator() (vector_t x, vector_t y, vector_t z)
{
   Point3D[VX] = x;
   Point3D[VY] = y;
   Point3D[VZ] = z;
   return *this;
}

void coord_c::
link_face (face_c& face)
{
   // Test NumberLinkedFace < 6 ..

   LinkedFace[NumberLinkedFace] = &face;
   NumberLinkedFace ++;
}

vector3_c& coord_c::
calcul2D (vector_t distance)
{
   Point2D[VX] = Point3D[VX]*distance/(distance-Point3D[VZ]);
   Point2D[VY] = Point3D[VY]*distance/(distance-Point3D[VZ]);
   return Point2D;
}

vector3_c& coord_c::
calcul_normale (void)
{
   word index;

   Normale(0,0,0);

   if (NumberLinkedFace > 0)
   {
      for(index=0; index<NumberLinkedFace; index++)
         Normale += LinkedFace[index]->Normale;

      Normale /= NumberLinkedFace;
   }

   return Normale;
}

material_c& coord_c::
calcul_material (void)
{
   word index;

   Material.erase();

   if (NumberLinkedFace > 0)
   {
      for(index=0; index<NumberLinkedFace; index++)
         Material += *(LinkedFace[index]->Material);

      Material /= NumberLinkedFace;
   }

   return Material;
}


rgb_c& coord_c::
calcul_color(light_c& light)
{
   return phong_color(light,Point3D,Normale,Material);
}