#include "face.h"
#include "camera.h"
#include "light.h"
#include "coord.h"
#include "object.h"
#include "fill.h"

#define DEFAULT_RED     0.3
#define DEFAULT_GREEN   0.6
#define DEFAULT_BLUE    1.0

face_c::
face_c(void)
{
}

face_c& face_c::
operator() (coord_c* p1, coord_c* p2, coord_c* p3)
{
   Point1=p1;
   Point2=p2;
   Point3=p3;
   TwoSide = TRUE;

   Point1->link_face(*this);
   Point2->link_face(*this);
   Point3->link_face(*this);

   return *this;
}

face_c& face_c::
operator= (face_c& face)
{
   Point1=face.Point1;
   Point2=face.Point2;
   Point3=face.Point3;
   //Color =face.Color;

   Point1->link_face(*this);
   Point2->link_face(*this);
   Point3->link_face(*this);
   return *this;
}

void face_c::
link_object (object_c& object)
{
   Object = &object;
   Material = Object->World->Material[0];
//   FillingFunction = fill_algo;
}

void face_c::
filling (face_filling_function_t fill_algo)
{
   FillingFunction = fill_algo;
}

void face_c::
filling (void)
{
   FillingFunction(*this);
}

// create center_z for the Zsort function

vector3_c& face_c::
calcul_center (void)
{
   return Center = ( Point1->Point3D +
                     Point2->Point3D +
                     Point3->Point3D) /3.0;
}

vector3_c& face_c::
center (void)
{
   return Center;
}

vector3_c& face_c::
calcul_normale (void)
{
   Normale = ((Point1->Point3D-Point3->Point3D)^
              (Point2->Point3D-Point3->Point3D));
   Normale.normalize();
   calcul_center();
   return Normale;
}


rgb_c& face_c::
calcul_color(light_c& light)
{
   return phong_color (light, Center, Normale, *Material);
}

bool face_c::
is_visible (void)
{
   return Normale[VZ]>0.0;
}

void face_c::
render (light_c& light)
{
   if (is_visible() || TwoSide)
   {
      calcul_color(light);
      filling();
   }
}