/*
 * INCLUDE FILE
 *
 * Version 1.0
 * Copyright 1996 Thomas MANGIN
 */


#ifndef BASE_2D_H
#define BASE_2D_H


#include "base.h"

enum {RED = 0, GREEN = 1, BLUE = 2};

class rgb_c;

typedef   byte    player_t;

typedef sdword    coord_t;          /* Coord to accees the screen */
typedef  sword    frame_t;          /* sprite animation reference */
typedef   byte    pixel_t;          /* 8Bits colors value         */
typedef   byte    color_t;


#ifdef _PUSHPOP_SUPPORTED
#pragma pack(__push,1);
#else
#pragma pack(1)
#endif

typedef struct rgb_s
{
   pixel_t red;
   pixel_t green;
   pixel_t blue;
}
rgb_t;

typedef struct rgbr_s
{
   pixel_t red;
   pixel_t green;
   pixel_t blue;
   pixel_t reserved;
}
rgbr_t;

typedef union
{
   struct
   {
      sdword red;
      sdword green;
      sdword blue;
      sdword reserved;
   } dword_value;

   struct
   {
       byte low_red_1  , low_red_2  , red  , hi_red  ;
       byte low_green_1, low_green_2, green, hi_green;
       byte low_blue_1 , low_blue_2 , blue , hi_blue ;
      dword reserved;
   } byte_value;

     byte byte_array[16];
   sdword dword_array[4];

} rgb_u;

typedef union
{
   struct
   {
       byte low_value_1  , low_value_2  , value  , hi_value  ;
   } byte_value;

   struct
   {
      sdword value;
   } dword_value;
}
float_8_16;

#ifdef _PUSHPOP_SUPPORTED
#  pragma pack(__pop);
#endif

#endif /* BASE_2D_H */