/*
 * INCLUDE FILE
 *
 * Version 1.0
 * Copyright 1996 Thomas MANGIN
 */

//
// Freely inspired from Graphics Gems IV (AP Professional)
//

#ifndef BASE_3D_H
#define BASE_3D_H

#include <math.h>
#include "base.h"

#ifndef M_PI
#define M_PI        3.14159265358979323846
#endif

#ifndef M_PI_2
#define M_PI_2      1.57079632679489661923
#endif

#ifndef M_PI_4
#define M_PI_4      0.785398163397448309616
#endif

enum {PA,PB,PC,PD};     // planes
enum {KA,KD,KS,ES};     // phong coeffs

class vector2_c;
class vector3_c;
class vector4_c;

class matrix3_c;
class matrix4_c;
class face_c;
class rgb_c;

typedef float vector_t;
typedef vector_t (*vector_function_ptr) (vector_t);

typedef face_c* ptr_face_c;
typedef void (*face_filling_function_t)(face_c&);

typedef  rgb_c    intensity_c;      /* 3D Light sources intensity */
typedef  rgb_c    reflection_c;     /* 3D Light sources reflection*/

typedef enum
{
   clipping_NONE     = 0x00,
   clipping_HIDDEN   = 0x01,
   clipping_PROJECT  = 0x02,
   clipping_Z_CLIP   = 0x04,
   clipping_LIGHT    = 0x08,
   clipping_VISIBLE  = 0x10
}
clipping_t;

#endif /* BASE_3D_H */