#ifndef CLASS_CAMERA_H
#define CLASS_CAMERA_H

#include "base3d.h"

#include "matrix4.h"
#include "vector3.h"

class camera_c
{
   private:
      vector3_c Origine;
      vector3_c Destination;
      vector_t  Bank; // No used
      vector_t  Fov; // No used
      vector_t  EyeDistance; // No used

      matrix4_c Transformation;

   public:
      camera_c (void);
      camera_c (vector3_c& v);
      camera_c (vector_t x, vector_t y, vector_t z);

      void origine (const vector3_c& new_origine);
      void destination (const vector3_c& new_destination);

      vector3_c& origine (void);
      vector3_c& destination (void);

      void look_at (vector3_c& v);    // not implemeted
      vector_t distance (void);
};

#endif