#ifndef CLASS_COORD_H
#define CLASS_COORD_H

#include "base3d.h"

#include "material.h"
#include "vector3.h"

class face_c;
class light_c;

class coord_c
{
    public:
      vector3_c   Point3D;
      vector3_c   Point2D;
      vector3_c   Normale;
      material_c  Material;
      rgb_c       Color;

      // On day will be private .. (Like All)
      word        NumberLinkedFace;
      face_c*     LinkedFace[40];

      // the world coordonate -> change the normal one
      // vector3_c WorldPoint3D;
      // byte* Texture;

      coord_c (void);
      coord_c (const coord_c& coord);

      coord_c& operator= (const coord_c& coord);
      coord_c& operator() (vector_t x, vector_t y, vector_t z);

      void link_face (face_c& face);

      vector3_c&   calcul2D        (vector_t distance);
      vector3_c&   calcul_normale  (void);
      material_c&  calcul_material (void);
      rgb_c&       calcul_color    (light_c& light);

};

#include "face.h"

#endif