#ifndef EXCEPTION_ERROR
#define EXCEPTION_ERROR

#include "main.h"

#define fatal(messy) throw EFatalMessy(messy);

// root exception
class ErrExit
{
   public:
      ErrExit(char* file, int line, char* messy)
      {
         IsError  = TRUE;
         File     = file;
         Line     = line;
         Messy    = messy;
      }
};


#define new_exception(name,parent)                 \
class name : public parent                         \
{                                                  \
   public:                                         \
      name (char* file, int line, char* msg)       \
      : parent (file,line, msg) {};                \
};


// Fatal exception
new_exception(ErrFatal        ,ErrExit)      /* Fatal error detected */
new_exception(ErrFatalRange   ,ErrFatal)     /* Values are out of range */
new_exception(ErrFatalFinish  ,ErrFatal)     /* Function is not finished */
new_exception(ErrFatalInstance,ErrFatal)     /* Function is not finished */
new_exception(ErrFatalMessy   ,ErrFatal)

// Normal exception
new_exception(ErrError        ,ErrExit)      /* All errors */

new_exception(ErrMemory       ,ErrError)     /* Memory allocation failed */

new_exception(ErrFile         ,ErrError)     /* Eror on file */
new_exception(ErrFileMode     ,ErrFile)      /* Invalid opening mode */
new_exception(ErrFileAccess   ,ErrFile)      /* Not enougth right to access */
new_exception(ErrFileCreate   ,ErrFile)      /* Can't create file */
new_exception(ErrFileOpen     ,ErrFile)      /* Can't open file */
new_exception(ErrFileClose    ,ErrFile)      /* Can't close file */
new_exception(ErrFileSeek     ,ErrFile)      /* Can't seek in file */
new_exception(ErrFileRead     ,ErrFile)      /* Can't read file */
new_exception(ErrFileWrite    ,ErrFile)      /* Can't write in file */
new_exception(ErrFileSize     ,ErrFile)      /* Can't change file size */
new_exception(ErrFileFormat   ,ErrFile)      /* The file is corrupted */
new_exception(ErrFileUnknow   ,ErrFile)      /* The file format is unknow */

new_exception(ErrScreen          ,ErrError)  /* Invalid screen action */
new_exception(ErrScreenMode      ,ErrScreen) /* Can't set mode ask for */
new_exception(ErrScreenAvailable ,ErrScreen) /* Can't set mode ask for */


#define EExit()               ErrExit           (__FILE__,__LINE__,"Exiting Due To Error")

#define EDebug()              ErrDebug          (__FILE__,__LINE__,"Debug Error")

#define EFatal()              ErrFatal          (__FILE__,__LINE__,"Fatal Error")
#define EFatalRange()         ErrFatalRange     (__FILE__,__LINE__,"Range Parameter Error")
#define EFatalFinish()        ErrFatalFinish    (__FILE__,__LINE__,"Function Not Finished. Sorry")
#define EFatalInstance()      ErrFatalInstance  (__FILE__,__LINE__,"Can't run No Instance of the Class")
#define EFatalMessy(mesg)     ErrFatalMessy     (__FILE__,__LINE__,mesg)

#define EMemory()             ErrMemory         (__FILE__,__LINE__,"Can't allocate memory")

#define EFile()               ErrFile           (__FILE__,__LINE__,"File")
#define EFileMode()           ErrFileMode       (__FILE__,__LINE__,"File Mode")
#define EFileAccess()         ErrFileAccess     (__FILE__,__LINE__,"File Access")
#define EFileCreate()         ErrFileCreate     (__FILE__,__LINE__,"File Create")
#define EFileOpen()           ErrFileOpen       (__FILE__,__LINE__,"File Open")
#define EFileClose()          ErrFileClose      (__FILE__,__LINE__,"File Close")
#define EFileSeek()           ErrFileSeek       (__FILE__,__LINE__,"File Seek")
#define EFileRead()           ErrFileRead       (__FILE__,__LINE__,"File Read")
#define EFileWrite()          ErrFileWrite      (__FILE__,__LINE__,"File Write")
#define EFileSize()           ErrFileSize       (__FILE__,__LINE__,"File Change Size")
#define EFileFormat()         ErrFileFormat     (__FILE__,__LINE__,"File Format Error")
#define EFileUnknow()         ErrFileUnknow     (__FILE__,__LINE__,"File Format Unknow")

#define EScreen()             ErrScreen         (__FILE__,__LINE__,"Screen")
#define EScreenMode()         ErrScreenMode     (__FILE__,__LINE__,"Can't set video mode")
#define EScreenAvailable()    ErrScreenAvailable(__FILE__,__LINE__,"Can't found video mode")

#endif