#ifndef CLASS_FACE_H
#define CLASS_FACE_H

#include "base3d.h"

#include "material.h"
#include "object.h"
#include "vector3.h"


class camera_c;
class light_c;
class material_c;

class face_c
{
   public:
      coord_c*    Point1;     // Three point coordonate
      coord_c*    Point2;
      coord_c*    Point3;
      bool        TwoSide;

      vector3_c   Center;     // Center of the triangle
      vector3_c   Normale;    // Normale of the face

      material_c* Material;   // Material propriety associated
      rgb_c       Color;      // Precalculation of the color relected

      object_c*   Object;     // Father Object
      face_filling_function_t   FillingFunction;   // Filling algorithm


      face_c   (void);
      face_c   (coord_c* p1, coord_c* p2, coord_c* p3);

      face_c&        operator()        (coord_c* p1, coord_c* p2, coord_c* p3);
      face_c&        operator=         (face_c& vertex);

      void           link_object       (object_c& object);

      void           filling           (face_filling_function_t fill_algo);
      void           filling           (void);

      vector3_c&     calcul_center     (void);
      vector3_c&     center            (void);
      vector3_c&     calcul_normale    (void);
      vector_t       normale           (void);
      rgb_c&         calcul_color      (light_c& light);

      bool           is_visible        (void);

      void           render            (light_c& light);
};
#endif