#ifndef CLASS_MAIN
#define CLASS_MAIN

#include "base.h"

extern bool  IsError;
extern char* File;
extern int   Line;
extern char* Messy;

int start (int argc, char** argv);

class CScreen;

class CMain
{
   private:

      FILE*             Stream;           // Stream used for print message
      char*             FileName;         // Name of the file associated
      FILE*             FileHandle;       // Stream File associated
      void_function_t   ExitCode;         // Function called at exit
      bool              ErrorReport;      // Print the error message
      void_function_t   ErrorCode;        // Function called when error

      void print_header ();

      // Extension Installed

   public:
       CMain ();
      ~CMain ();

      char* version_string ();
      word  vesion_major();
      word  vesion_minor();

      void  set_log     (char *file_name, FILE * stream);
      // File_name = file where the stream is redirected
      // (NULL == no redirection)

      void error_report (bool state);
      // Are we printing the final error report

      void  error_code (void_function_t function);
      // Code called before error exiting

      void  exit_code (void_function_t function);
      // Code called after the video mode restoration

      void  error (char* text);
      // exit and print text (error stream)

      void print (char* text, char* file, int line);
      // print on log a message


      int run (int argc, char** argv);
      // call start
};


extern CMain Slhan;

#endif