#ifndef MODEX_H
#define MODEX_H

#include "base.h"

#define ATTRCON_ADDR    0x3C0
#define MISC_ADDR       0x3C2
#define VGAENABLE_ADDR  0x3C3
#define SEQU_ADDR       0x3C4
#define GRACON_ADDR     0x3CE
#define CRTC_ADDR       0x3D4
#define STATUS_ADDR     0x3DA

#define PLANE_0         0x0102
#define PLANE_1         0x0202
#define PLANE_2         0x0402
#define PLANE_3         0x0802
#define ALL_PLANES      0x0F02
#define READ_PLANE_0    0x0004
#define READ_PLANE_1    0x0104
#define READ_PLANE_2    0x0204
#define READ_PLANE_3    0x0304


extern word     Width, Height, WidthByte, NumPage;
extern word     ActiveStart, VisibleStart, PageSize;
extern sbyte    WritePlane, ReadPlane;
extern byte*    Row[600];
extern byte     LineHead[4];
extern byte     LineTail[4];
extern word     PlaneMask[4];
extern word     ReadMask[4];
extern word     TextMask[16];
extern word     PageOffset[5];
extern word     PageMaskHigh[5];
extern word     PageMaskLow[5];


void set_80x25(void);
void set_320x400x256(void);
void set_320x480x256(void);
void set_400x300x256(void);
void set_400x600x256(void);
void set_640x480x256(void);

word get_x(void);
word get_y(void);

void wait_vbl (void);
void clear(byte color);
void put_pixel(word x, word y, byte color);
void plot (float x, float y, float r, float g, float b);
void set_color(byte index, byte r, byte g, byte b);
void init_video (void);

#endif