#ifndef CLASS_OBJECT_H
#define CLASS_OBJECT_H

#include "base3d.h"

#include "face.h"
#include "object.h"

class camera_c;
class coord_c;
class face_c;
class light_c;
class object_c;
class world_c;

#define OBJECT_MAX_CHILD   10

class object_c
{
   private:
      word        MaxVertex;
      word        MaxFace;
      word        CurrentVertex;
      word        CurrentFace;
      word        ClippingState;

   public:
      char      Name[20];      // Not used
      coord_c*  Vertex;
      face_c*   Face;
      world_c*  World;
      object_c* Child[OBJECT_MAX_CHILD];

      object_c(world_c* world);
      object_c(world_c* world,word nb_vertex);
      object_c(world_c* world,word nb_vertex, word nb_face);

//      vertex_c& vertex (word index);
//      face_c&   face   (word index);

      void nb_vertex (word nb);
      word nb_vertex (void);

      void nb_face (word nb);
      word nb_face (void);

      void add_vertex(vector_t x, vector_t y, vector_t z);
      void add_face(word index1, word index2, word index3, face_filling_function_t filling_algo);
};

#endif