//
// Freely inspired from Graphics Gems IV (AP Professional)
//

#ifndef CLASS_COLOR_H
#define CLASS_COLOR_H

#include "base2d.h"

class rgb_c
{
   protected:
      rgb_u C;

   private:
      rgb_c (const sdword r, const sdword g, const sdword b, const sdword diff);

   public:
      rgb_c (void);
      rgb_c (const ubyte r, const ubyte g, const ubyte b);
      rgb_c (const rgb_c& c);

      rgb_c& operator  = (const rgb_c& c);
      rgb_c& operator -= (const rgb_c& c);
      rgb_c& operator += (const rgb_c& c);
      rgb_c& operator *= (const sdword d);
      rgb_c& operator /= (const sdword d);
      rgb_c& operator /= (const float  d);
      rgb_c& operator () (const ubyte r, const ubyte g, const ubyte b);
      rgb_c& operator () (const rgb_c& c);
      ubyte& operator [] (const word i);
      ubyte& red (void);
      ubyte& green (void);
      ubyte& blue (void);

      void     print (void);

      friend void swap (rgb_c& v1, rgb_c& v2);
      friend rgb_c min  (const rgb_c& v1, const rgb_c& v2);
      friend rgb_c max  (const rgb_c& v1, const rgb_c& v2);

      friend rgb_c operator - (const rgb_c& c1, const rgb_c& c2);
      friend rgb_c operator + (const rgb_c& c1, const rgb_c& c2);

      friend rgb_c operator  * (const rgb_c& c , const sdword d);
      friend rgb_c operator  * (const sdword d , const rgb_c& c);

      friend rgb_c operator  / (const rgb_c& c , const sdword  d);
      friend rgb_c operator  / (const rgb_c& c , const float   d);
      friend rgb_c operator  ^ (const rgb_c& c1, const rgb_c& c2);

      friend bool       operator == (const rgb_c& c1, const rgb_c& c2);
      friend bool       operator != (const rgb_c& c1, const rgb_c& c2);
      friend ostream&   operator << (ostream& s, const rgb_c& c);
};

#endif