#ifndef CLASS_WORLD_H
#define CLASS_WORLD_H

#define MAX_OBJECT   100
#define MAX_MATERIAL 100

#include "base3d.h"

class face_c;
class object_c;
class camera_c;
class light_c;
class material_c;

typedef enum
{
   render_flat    = 0x01,
   render_gouraud = 0x02,
   render_phong   = 0x04,
   render_texture = 0x08
}
render_t;

void filling (face_c& face);

class world_c
{
   public:
       world_c(void);
       world_c(char* file_name);
      ~world_c(void);

      bool is_valid (void);
      void initialize_3ds (char* file_name);

      void  add_object (void);
      sword current_object (void);

      void nb_vertice (sword index_object, word number);
      void add_vertex (sword index_object, vector_t x, vector_t y, vector_t z);

      void nb_face (sword index_object, word number);
      void add_face(sword index_object, word index1, word index2, word index3, face_filling_function_t filling_algo);

      void rendering (render_t type);
      face_filling_function_t rendering (void);

      void render (void);

   // private:
      // Public for simplification
      sword       CurrentObject;
      sword       CurrentMaterial;

      object_c*   Object[MAX_OBJECT];
      material_c* Material[MAX_MATERIAL];

      camera_c*   Camera;
      light_c*    Light;

      word        NbFace;  // Change for dword
      ptr_face_c* ZSort;

      void init_normale  (void);
      void init_material (void);
      void init_zsort    (void);

      void print_info    (void);
};

#endif