#include <dos.h>
#include <bios.h>

#include "base3d.h"
#include "debug.h"
#include "main.h"
#include "video.h"

#include "camera.h"
#include "coord.h"
#include "fill.h"
#include "light.h"
#include "tds.h"
#include "vbl.h"
#include "world.h"

// Include of the global object in the world

int start (int argc, char** argv)
{
   bool     looping = TRUE;
   world_c* world;
   byte     key_press;
   word     i;

   if(argc < 2)
      fatal("Nb Arg");

   world = new world_c(argv[1]);

   video_init();
   vbl_start();


//   world->rendering(render_gouraud);

   while(looping)
   {
      vbl_wait();
      video_clear(0x88);
      world->render();

      world->Light->Origine.calcul2D(world->Camera->distance());
      video_plot
      (
         world->Light->Origine.Point2D[VX] +video_mid_x(),
         world->Light->Origine.Point2D[VY] +video_mid_y(),
         255, 255, 255
      );

//      if (kbhit())
      {
         key_press= _bios_keybrd (_KEYBRD_READ);
         switch (key_press)
         {
            case 0x011B:  // ESCAPE KEY
            case 0x1071:  // Q
            case 0x2D78:  // X
               looping = FALSE;
               break;

            case 0x2166:   // F
               world->rendering(render_flat);
               break;
            case 0x2267:   // G
               world->rendering(render_gouraud);
               break;
            case 0x1970:   // P
               world->rendering(render_phong);
               break;

            case 0x4E2B:   // +
               world->Light->Origine.Point3D[VZ]+=10;
               break;
            case 0x4A2D:   // -
               world->Light->Origine.Point3D[VZ]-=10;
               break;
            case 0x5032:   // 2
               world->Light->Origine.Point3D[VY]+=10;
               break;
            case 0x4838:   // 8
               world->Light->Origine.Point3D[VY]-=10;
               break;
            case 0x4D36:   // 6
               world->Light->Origine.Point3D[VX]+=10;
               break;
            case 0x4B34:   // 4
               world->Light->Origine.Point3D[VX]-=10;
               break;
            case 0x4C35:   // 5
               world->Light->Origine.Point3D(0,0,200);
               break;
         }
      }
   }
   vbl_stop ();

   video_80x25();

   world->print_info();
   vbl_print_info();

   return 0;
}