#include <conio.h>
#include <dos.h>
#include <mem.h>

#include "debug.h"
#include "modex.h"
#include "modex.def"


byte*  Row[600];

word  Width, Height, WidthByte, NumPage;
word  PageSize, ActiveStart, VisibleStart;
sbyte WritePlane, ReadPlane;
byte  LineHead[4] = { 0xFF, 0x0E, 0x0C, 0x08 };
byte  LineTail[4] = { 0x00, 0x01, 0x03, 0x07 };
word  PlaneMask[4] = { PLANE_0, PLANE_1, PLANE_2, PLANE_3 };
word  ReadMask[4]  = { READ_PLANE_0, READ_PLANE_1,
							  READ_PLANE_2, READ_PLANE_3 };
word  TextMask[16] = { 0x0002, 0x0102, 0x0202, 0x0302,
							  0x0402, 0x0502, 0x0602, 0x0702,
							  0x0802, 0x0902, 0x0A02, 0x0B02,
							  0x0C02, 0x0D02, 0x0E02, 0x0F02 };

word  PageOffset[5];
word  PageMaskHigh[5];
word  PageMaskLow[5];


void wait_vbl (void)
{
   while ( (inp (0x3DA) & 8) == 8 );
   while ( (inp (0x3DA) & 8) == 0 );
}

void clear (byte color)
{
	outpw(SEQU_ADDR,ALL_PLANES);
   memset((byte *)(0xA000 << 4) + ActiveStart, color, 0x10000L);
}

void put_pixel(word x, word y, byte color)
{
   byte temp;

   debug_error(x>=get_x() || x<0 || y>=get_y() || y<0)

	if (WritePlane != (temp = (x & 3)))
	{
		WritePlane = temp;
		outpw(SEQU_ADDR, PlaneMask[temp]);
	}
	*(Row[y] + (x >> 2) + ActiveStart) = color;
}


void plot (float x, float y, float r, float g, float b)
{
   switch ((dword)x %3)
   {
      case 0:
         put_pixel(x,y*3+0,r*63);
         put_pixel(x,y*3+1,64+g*63);
         put_pixel(x,y*3+2,2*64+b*63);
         break;
      case 1:
         put_pixel(x,y*3+1,r*63);
         put_pixel(x,y*3+2,64+g*63);
         put_pixel(x,y*3+0,2*64+b*63);
         break;
      case 2:
         put_pixel(x,y*3+2,r*63);
         put_pixel(x,y*3+0,64+g*63);
         put_pixel(x,y*3+1,2*64+b*63);
         break;
   }
}

void set_color(byte index, byte r, byte g, byte b)
{
   outp(0x03c8, (char) index);
   outp(0x03c9, (char) r);
   outp(0x03c9, (char) g);
   outp(0x03c9, (char) b);
}

void init_video (void)
{
   union REGS  r;
   int i;

   set_320x480x256();

   for(i=0;i<64;i++)
   {
      set_color(0*64+i,i,0,0);
      set_color(1*64+i,0,i,0);
      set_color(2*64+i,0,0,i);
      set_color(3*64+i,0,i,i);
   }
      set_color(255,63,63,63);
}


void calc_row(void)
{
	int i;

	WidthByte = Width/4;
	PageSize = (WidthByte * Height);

	for (i=0; i < Height; i++)
	{
		#ifdef __WATCOMC__
         Row[i] = (byte *)((0xA000 << 4) + (WidthByte * i));
		#else
         Row[i] = (byte FAR*)MK_FP(0xA000,WidthByte * i);
		#endif
	}

	outpw(SEQU_ADDR, ALL_PLANES);
	#ifdef __WATCOMC__
      memset((byte *)(0xA000 << 4), 0x00, 0x10000L);
	#else
		MEMSET(0xA000, 0x0000, 0x00, 0x10000L);
	#endif

	ActiveStart = VisibleStart = 0;
	WritePlane = -1;
	ReadPlane  = -1;

   #ifdef __WATCOMC__
		NumPage = ((64 * 1024) / PageSize);
	#else
		NumPage = (0xFFFF / PageSize);
	#endif

	for (i=0; i < NumPage; i++)
	{
		PageOffset[i] = PageSize * i;
		PageMaskHigh[i] = 0x0C | (PageOffset[i] & 0xFF00);
		PageMaskLow[i]  = 0x0D | ((PageOffset[i] & 0x00FF) << 8);
	}
}

void SetBaseMode(void)
{
	int temp;
	union REGS r;

   r.x.eax = 0x0013;
   int386(0x10, &r, &r);

    outp(0x3D4, 0x11);
    temp = inp(0x3D5) & 0x7F;
    outp(0x3D4, 0x11);
    outp(0x3D5, temp);
}


void OutReg(word *r)
{
    switch (r[0])
    {
        case ATTRCON_ADDR:
            inp(STATUS_ADDR);
            outp(ATTRCON_ADDR, r[1] | 0x20);
            outp(ATTRCON_ADDR, r[2]);
            break;

        case MISC_ADDR:
        case VGAENABLE_ADDR:
            outp(r[0], r[2]);
            break;

        case SEQU_ADDR:
        case GRACON_ADDR:
        case CRTC_ADDR:
        default:
            outp(r[0], r[1]);
            outp(r[0] + 1, r[2]);
            break;
    }
}

void OutRegArray(word *r, int n)
{
    while (n--)
    {
        OutReg(r);
        r += 3;
    }
}

void set_80x25(void)
{
    union REGS r;

   r.x.eax = 0x0003;
   int386(0x10, &r, &r);
}


void set_320x400x256(void)
{
    SetBaseMode();
    OutRegArray(ModeX_320x400regs, 25);
    Width  = 320;
    Height = 400;
    calc_row();
}


void set_320x480x256(void)
{
    SetBaseMode();
    OutRegArray(ModeX_320x480regs, 25);
    Width  = 320;
    Height = 480;
    calc_row();
}

void set_400x300x256(void)
{
    SetBaseMode();
	 OutRegArray(ModeX_400x300regs, 26);
	 Width  = 400;
	 Height = 300;
	 calc_row();
}


void set_400x600x256(void)
{
	 SetBaseMode();
	 OutRegArray(ModeX_400x600regs, 26);
	 Width  = 400;
	 Height = 600;
	 calc_row();
}


word get_x (void)
{
    return Width;
}


word get_y (void)
{
    return Height;
}


void SetWritePlane(word plane_mask)
{
    WritePlane = -1;
    outpw(SEQU_ADDR, plane_mask);
}


void SetReadPlane(word plane_mask)
{
    ReadPlane = -1;
    outpw(GRACON_ADDR, plane_mask);
}