#include "debug.h"

#include "camera.h"
#include "coord.h"
#include "face.h"
#include "object.h"

object_c::
object_c(world_c* world)
{
   World = world;
   MaxVertex = 0;
   MaxFace   = 0;
   Vertex   = NULL;
   Face     = NULL;
   CurrentFace    = 0;
   CurrentVertex  = 0;
}

object_c::
object_c(world_c* world,word nb_vertex)
{
   World = world;
   MaxVertex = nb_vertex;
   MaxFace   = 0;
   Vertex   = new coord_c[MaxVertex];
   Face     = NULL;
   CurrentFace    = 0;
   CurrentVertex  = 0;
}

object_c::
object_c(world_c* world,word nb_vertex, word nb_face)
{
   World = world;
   MaxVertex = nb_vertex;
   MaxFace   = nb_face;
   Vertex   = new coord_c[MaxVertex];
   Face     = new face_c[MaxFace];
   CurrentFace    = 0;
   CurrentVertex  = 0;
}

void object_c::
nb_vertex (word nb)
{
   MaxVertex = nb;
   delete Vertex;
   Vertex   = new coord_c[MaxVertex];
   CurrentVertex  = 0;
}

word object_c::
nb_vertex (void)
{
   return CurrentVertex;
}

void object_c::
nb_face (word number)
{
   MaxFace = number;
   delete Face;
   Face = new face_c[MaxFace];
   CurrentFace    = 0;
}

word object_c::
nb_face (void)
{
   return CurrentFace;
}

void object_c::
add_vertex(vector_t x, vector_t y, vector_t z)
{
   debug_if(Vertex==NULL,"Vertices array not allocated.");
   debug_if(CurrentVertex==MaxVertex,"Too many vertices inserted.");

   Vertex[CurrentVertex](x,y,z);
   CurrentVertex++;
}

void object_c::
add_face(word index1, word index2, word index3, face_filling_function_t filling_algo)
{
   debug_if(Face==NULL,"Face array not allocated.");
   debug_if(CurrentFace==MaxFace,"Too many face inserted.");

   Face[CurrentFace](&Vertex[index1],&Vertex[index2],&Vertex[index3]);
   Face[CurrentFace].link_object(*this);
   Face[CurrentFace].filling(filling_algo);
   CurrentFace++;
}