#include <dos.h>
#include <bios.h>

#include "new_handler"

#include "base.h"
#include "base3d.h"
#include "camera.h"
#include "coord.h"
#include "debug.h"
#include <time.h>

#include "fill.h"
#include "light.h"
#include "screen.h"
#include "tds.h"
#include "vbl.h"
#include "video.h"
#include "world.h"


// Include of the global object in the world

void main (int argc, char** argv)
{
   word     looping;
   world_c* world;
   time_t   timer_before;
   time_t   timer_after;

   if(argc < 2)
      world = new world_c("data\\2torus.3ds");
   else
      world = new world_c(argv[1]);

   video_init();
   vbl_start();

   world->rendering(render_gouraud);

   looping = 20;
   time(&timer_before);

   while(looping)
   {
      vbl_wait();
      video_clear(0x88);
      world->render();

      world->Light->Origine.calcul2D(world->Camera->distance());
      video_plot
      (
         world->Light->Origine.Point2D[VX] +video_mid_x(),
         world->Light->Origine.Point2D[VY] +video_mid_y(),
         255, 255, 255
      );

      looping--;
   }

   vbl_stop ();
   time(&timer_after);

   video_80x25();
   vbl_print_info();

   printf("Diff Time : %f\n",difftime(timer_after,timer_before));
   printf("Sub  Time : %ld\n",(dword)timer_after-(dword)timer_before);
}