#include "debug.h"

#include "vector.h"

vector_c::
vector_c(void) : vector3_c()
{
   origine(0,0,0);
}

vector_c::
vector_c(const vector3_c& new_origine) : vector3_c()
{
   origine(new_origine);
}

vector_c::
vector_c(const vector3_c& new_origine, const vector3_c& dest)
 : vector3_c()
{
   Origine = new_origine;
   destination(dest);
}

vector_c& vector_c::
operator= (const vector_c& v)
{
   Origine = v.Origine;
   destination(v.Destination);
   return *this;
}

vector_c vector_c::
operator+ (const vector_c& v)
{
   return *this+v;
}

void vector_c::
origine (const vector3_c& new_origine)
{
   Origine = new_origine;
   (vector3_c)(*this) = (Destination - Origine);
}

void vector_c::
destination (const vector3_c& new_dest)
{
   Destination = new_dest;
   (vector3_c)(*this) = (Destination - Origine);
}

void vector_c::
vector (const vector3_c& v)
{
   Destination = Origine+v;
   (vector3_c)(*this) = (vector3_c&)v;
}

void vector_c::
origine (vector_t x, vector_t y, vector_t z)
{
   Origine(vector3_c(x,y,z));
}

void vector_c::
destination (vector_t x, vector_t y, vector_t z)
{
   Destination(vector3_c(x,y,z));
}

void vector_c::
vector (vector_t x, vector_t y, vector_t z)
{
   destination(x+Origine[VX],y+Origine[VY],z+Origine[VZ]);
}

vector3_c& vector_c::
origine (void)
{
   return Origine;
}

vector3_c& vector_c::
destination (void)
{
	return Destination;
}

vector3_c& vector_c::
vector (void)
{
   return (vector3_c&)*this;
}