#include <dos.h>
#include <conio.h>

#include "debug.h"

#include "video.h"

void video_init (void)
{
   if (!vesa_init_system(SCREEN_X,SCREEN_Y,BPP))
   {
      printf("Can't init Linear %dx%dx%dk",SCREEN_X,SCREEN_Y,BPP);
      exit(0);
   }
}

void video_restore (void)
{
   union REGS  r;

   r.rword.ax = 0x03;
	int386(0x10,&r,&r);
}

void video_80x25(void)
{
    union REGS r;

   r.x.eax = 0x0003;
   int386(0x10, &r, &r);
}


word video_get_x (void)
{
   return SCREEN_X;
}

word video_get_y (void)
{
   return SCREEN_Y;
}

word video_mid_x (void)
{
   return SCREEN_MID_X;
}

word video_mid_y (void)
{
   return SCREEN_MID_Y;
}

void video_wait_vbl (void)
{
   while ( (inp (0x3DA) & 8) == 8 );
   while ( (inp (0x3DA) & 8) == 0 );
}

void video_clear (void)
{
   vesa_clear_screen();
}

void video_clear (ubyte color)
{
   vesa_clear_screen(color);
}

void video_plot (float x, float y, ubyte r, ubyte g, ubyte b)
{
//   debug_if(x<0 || x>=SCREEN_X || y<0 && y>=SCREEN_Y,"Illegal plot");

   if(x<0 || x>=SCREEN_X || y<0 && y>=SCREEN_Y)
      return ;

   #if (BPP == 16)
      plot16((dword)x,(dword)y,r,g,b);
   #else
      plot24((dword)x,(dword)y,r,g,b);
   #endif
}