#include <conio.h>
#include <i86.h>

byte  NbLineY;
byte  ScreenWidth;
word  VesaMode;
byte  VideoMode;
bool  Restored;

// Public
void save_mode ();
void restore_mode ();



void save_mode ()
{
   union    REGS r;
   word     index;

   Restored = FALSE;

   // wait vbl
   while ( (inp (0x3DA) & 8) == 8 );
   while ( (inp (0x3DA) & 8) == 0 );

   // SAVE THE SCREEN SIZE AND OLD LINE

   ScreenWidth  = *((byte*)0x044A);
   NbLineY      = *((byte*)0x0484);  // IF 80x25 80x43 80x50

   // READ THE VIDEO MODE

   r.rword.ax = 0x4F03;
   int386(0x10,&r,&r);

   if(r.h.al == 0x4F && r.rword.bx >= 0x100)
      VesaMode = r.rword.bx;
   else
   {
      VesaMode = 0;
      r.h.ah = 0x0F;
      int386(0x10,&r,&r);
      VideoMode = r.rbyte.al;
   }
}

void restore_mode ()
{
   union    REGS r;
   word     index;

   byte  nb_line_y;
   byte  screen_width;
   word  vesa_mode;
   byte  video_mode;

   if(Restored)
      return;
   else
      Restored = TRUE;

   // wait vbl
   while ( (inp (0x3DA) & 8) == 8 );
   while ( (inp (0x3DA) & 8) == 0 );


   screen_width  = *((byte*)0x044A);
   nb_line_y     = *((byte*)0x0484);  // IF 80x25 80x43 80x50

   // READ THE VIDEO MODE

   r.rword.ax = 0x4F03;
   int386(0x10,&r,&r);

   if(r.h.al == 0x4F && r.rword.bx >= 0x100)
      vesa_mode = r.rword.bx;
   else
   {
      vesa_mode = 0;
      r.h.ah = 0x0F;
      int386(0x10,&r,&r);
      video_mode = r.rbyte.al;
   }

   if (
         nb_line_y      == NbLineY     &&
         screen_width   == ScreenWidth &&
         vesa_mode      == VesaMode    &&
         video_mode     == VideoMode
      )
         return ;

   // RESTORE THE SCREEN SIZE AND OLD LINE
   if (VesaMode != 0)
   {
      r.rword.ax = 0x4F02;
      r.rword.bx = VesaMode;
      int386(0x10,&r,&r);
   }
   else
   {
      r.rdword.eax = VideoMode;
      int386(0x10,&r,&r);

      // Set mode 80x25 80x43 80x50
      switch (NbLineY)
      {
         case 0x18:
            r.rbyte.al = 0x14;
            break;
         case 0x1B:
            r.rbyte.al = 0x11;
            break;
         default:
            r.rbyte.al = 0x12;
            break;
      }

      r.rbyte.ah = 0x11;
      r.rword.bx = 0x00;
      int386(0x10,&r,&r);
   }

   *((byte*)0x044A) = ScreenWidth;
   *((byte*)0x0484) =NbLineY;

}